// Code generated by mockery v2.53.0. DO NOT EDIT.

package db

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
	models "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-api/internal/models"
)

// MockProjectVariableSets is an autogenerated mock type for the ProjectVariableSets type
type MockProjectVariableSets struct {
	mock.Mock
}

// AddProjectVariablesToSet provides a mock function with given fields: ctx, variableSet, variables
func (_m *MockProjectVariableSets) AddProjectVariablesToSet(ctx context.Context, variableSet *models.ProjectVariableSet, variables []*models.ProjectVariable) error {
	ret := _m.Called(ctx, variableSet, variables)

	if len(ret) == 0 {
		panic("no return value specified for AddProjectVariablesToSet")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.ProjectVariableSet, []*models.ProjectVariable) error); ok {
		r0 = rf(ctx, variableSet, variables)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// CreateProjectVariableSet provides a mock function with given fields: ctx, variableSet
func (_m *MockProjectVariableSets) CreateProjectVariableSet(ctx context.Context, variableSet *models.ProjectVariableSet) (*models.ProjectVariableSet, error) {
	ret := _m.Called(ctx, variableSet)

	if len(ret) == 0 {
		panic("no return value specified for CreateProjectVariableSet")
	}

	var r0 *models.ProjectVariableSet
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.ProjectVariableSet) (*models.ProjectVariableSet, error)); ok {
		return rf(ctx, variableSet)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.ProjectVariableSet) *models.ProjectVariableSet); ok {
		r0 = rf(ctx, variableSet)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.ProjectVariableSet)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.ProjectVariableSet) error); ok {
		r1 = rf(ctx, variableSet)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteProjectVariableSet provides a mock function with given fields: ctx, variableSet
func (_m *MockProjectVariableSets) DeleteProjectVariableSet(ctx context.Context, variableSet *models.ProjectVariableSet) error {
	ret := _m.Called(ctx, variableSet)

	if len(ret) == 0 {
		panic("no return value specified for DeleteProjectVariableSet")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.ProjectVariableSet) error); ok {
		r0 = rf(ctx, variableSet)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetProjectVariableSetByID provides a mock function with given fields: ctx, id
func (_m *MockProjectVariableSets) GetProjectVariableSetByID(ctx context.Context, id string) (*models.ProjectVariableSet, error) {
	ret := _m.Called(ctx, id)

	if len(ret) == 0 {
		panic("no return value specified for GetProjectVariableSetByID")
	}

	var r0 *models.ProjectVariableSet
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.ProjectVariableSet, error)); ok {
		return rf(ctx, id)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.ProjectVariableSet); ok {
		r0 = rf(ctx, id)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.ProjectVariableSet)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetProjectVariableSetByPRN provides a mock function with given fields: ctx, prn
func (_m *MockProjectVariableSets) GetProjectVariableSetByPRN(ctx context.Context, prn string) (*models.ProjectVariableSet, error) {
	ret := _m.Called(ctx, prn)

	if len(ret) == 0 {
		panic("no return value specified for GetProjectVariableSetByPRN")
	}

	var r0 *models.ProjectVariableSet
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.ProjectVariableSet, error)); ok {
		return rf(ctx, prn)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.ProjectVariableSet); ok {
		r0 = rf(ctx, prn)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.ProjectVariableSet)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, prn)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetProjectVariableSets provides a mock function with given fields: ctx, input
func (_m *MockProjectVariableSets) GetProjectVariableSets(ctx context.Context, input *GetProjectVariableSetsInput) (*ProjectVariableSetsResult, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for GetProjectVariableSets")
	}

	var r0 *ProjectVariableSetsResult
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *GetProjectVariableSetsInput) (*ProjectVariableSetsResult, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *GetProjectVariableSetsInput) *ProjectVariableSetsResult); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*ProjectVariableSetsResult)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *GetProjectVariableSetsInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateProjectVariableSet provides a mock function with given fields: ctx, variableSet
func (_m *MockProjectVariableSets) UpdateProjectVariableSet(ctx context.Context, variableSet *models.ProjectVariableSet) (*models.ProjectVariableSet, error) {
	ret := _m.Called(ctx, variableSet)

	if len(ret) == 0 {
		panic("no return value specified for UpdateProjectVariableSet")
	}

	var r0 *models.ProjectVariableSet
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.ProjectVariableSet) (*models.ProjectVariableSet, error)); ok {
		return rf(ctx, variableSet)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.ProjectVariableSet) *models.ProjectVariableSet); ok {
		r0 = rf(ctx, variableSet)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.ProjectVariableSet)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.ProjectVariableSet) error); ok {
		r1 = rf(ctx, variableSet)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// NewMockProjectVariableSets creates a new instance of MockProjectVariableSets. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockProjectVariableSets(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockProjectVariableSets {
	mock := &MockProjectVariableSets{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
